/******************************************************************************/
/* FONTS                                                                  */
/******************************************************************************/

@font-face {
	font-family: 'Bebas Neue';
	src: url('fonts/BebasNeue-Bold.otf') format('opentype');
	font-weight: bold;
	font-style: normal;
}

/******************************************************************************/
/* CONSTANTS                                                                  */
/******************************************************************************/

:root {
	--background-color: #2c2c2c;
	--accent-color: #ffd267;
	--accent-shadow-color: #ffd26730;
	--accent-outline-color: #ffecbf;
	--accent-outline-shadow-color: #ffecbf60;
	--accent-contrast-color: #000;
	--text-color: #cbcbcb;
	--text-auxiliary-color: #8c8c8c;
	--title-color: #fff;
	--max-content-width: 65em;
}

/******************************************************************************/
/* COMMON ELEMENTS                                                            */
/******************************************************************************/

body {
	min-height: 100vh;
	display: grid;
	grid-template-areas: 'header' 'content' 'footer';
	grid-template-rows: 64px 1fr auto;
	margin: 0;
	font-family: sans-serif;
	font-size: 12pt;
	color: var(--text-color);
	background-color: var(--background-color);
}

pre {
	background-color: #202020;
	border: 1px solid #333;
	padding: 0.5em;
	tab-size: 4;
	border-radius: 0.5em;
	overflow-x: auto;
	counter-reset: line;
}

p.preface { font-weight: bold; margin-top: 0; margin-bottom: 2rem; }
p.preface strong { color: var(--title-color); }

a { color: var(--title-color); }

a.active {
	color: var(--accent-color);
	font-weight: bold;
}

code { color: #eee; border: 1px solid #444; padding: 0 0.25em; background-color: #303030; }
pre > code { color: #eee; border: none; background: none; padding: 0; }

strong { color: #ddd; }

h1, h2, h3 { font-family: "Bebas Neue"; font-weight: bold; color: var(--title-color); }
h1 { margin-top: 0; color: #eee; }
h2 { margin-top: 3rem; color: #eee; font-size: 36px; }
h3 { margin-top: 2rem; color: #ddd; }
h1.brand { font-size: 72px; margin-top: 1em; margin-bottom: 2rem; margin-left: -0.1em; }
h1.brand em { color: var(--accent-color); font-style: normal; }
div > h2:first-child { margin-top: 0; }


code span.punctuation { color: #fff; }
code span.keyword { color: #f92472; }
code span.type { color: #67d8ef; }
code span.identifier { color: #fff; }
code span.string, code span.character { color: #e7db74; }
code span.number { color: #a980ff; }
code span.comment { color: #74705d; }
code span.invalid { color: #fff; background-color: #f92472; }

.brand {
	font-family: "Bebas Neue";
	font-weight: bold;
}

hr {
	border: none;
	background: none;
	border-top: dashed 2px #80808040;
	margin: 4rem 0;
}


/******************************************************************************/
/* PAGE LAYOUT                                                                */
/******************************************************************************/

section.cols-1-1, section.cols-2-1 {
	display: grid;
	grid-template-areas: "c1 c2";
	gap: 2rem 4rem;
}

section.cols-1-1 { grid-template-columns: 1fr 1fr; }
section.cols-2-1 { grid-template-columns: 2fr 1fr; }

.col:nth-child(1) { grid-area: c1; }
.col:nth-child(2) { grid-area: c2; }
.col:nth-child(3) { grid-area: c3; }


.right-float {
	background-color: #353535;
	border: 1px solid #494949;
	border-radius: 16px;
	box-shadow: 0 0 20px rgb(0 0 0 / 0.3);
	float: right;
	padding: 16px;
	margin-left: 4rem;
}
.right-float h2 { font-size: 24px; }
.right-float h3 { font-size: 16px; }
.right-float ul { margin: 0; padding: 0; list-style: none; }
.right-float li { margin: 0; padding: 0; }
.right-float li a { color: var(--text-auxiliary-color); text-decoration: none; font-size: 12px; font-weight: bold; }
.right-float li a h3 { font-family: sans-serif; margin-top: 0; }



/******************************************************************************/
/* HEADER                                                                     */
/******************************************************************************/

body > header {
	background-color: var(--accent-color);
	border-bottom: 1px solid var(--accent-outline-color);
	box-shadow: 0 0 20px var(--accent-shadow-color),
		inset 0 0 20px var(--accent-outline-shadow-color);
	color: var(--accent-contrast-color);
}

body > header > .container {
	max-width: var(--max-content-width);
	margin: 0 auto;
	grid-area: header;
	display: grid;
	grid-template-areas:
		"logo brand menu";
	grid-template-columns: 68px max-content 1fr;
}

body > header div.logo {
	grid-area: logo;
	width: 64px;
	height: 64px;
	background-image: url(img/logo.svg);
	background-size: 100% 100%;
}

body > header div.brand {
	grid-area: brand;
	align-self: center;
	font-size: 32px;
	padding-top: 6px;
	padding-bottom: 0px;
	display: inline-block;
}

body > header nav {
	grid-area: menu;
	align-self: center;
	text-align: right;
}

body > header a { color: inherit; text-decoration: none; }
body > header a.active { color: inherit; font-weight: bold; }

body > header li { display: inline-block; margin: 0 1em; }


/******************************************************************************/
/* FOOTER                                                                     */
/******************************************************************************/

body > footer {
	background-color: #262628;
	border-top: 1px solid #222;
	box-sizing: border-box;
	color: var(--text-auxiliary-color);
	padding: 1rem;
}

body > footer > .container {
	max-width: var(--max-content-width);
	margin: 0 auto;
	text-align: center;
}

/******************************************************************************/
/* CONTENT                                                                    */
/******************************************************************************/

.content {
	box-sizing: border-box;
	padding: 1rem;
	max-width: var(--max-content-width);
	width: 100vw;
	margin: 0 auto;
}
.content > nav {
	box-sizing: border-box;
	grid-area: nav;
	background-image: linear-gradient(90deg, var(--background-color), #262628);
	border-right: 1px solid #222;
	color: #f8f8ff;
	padding: 1rem;
}

.content > nav > ul {
	list-style: none;
	padding: 0;
	margin: 0
}

.content > nav > ul > li, nav > ol > li {
	padding: 0.25em 0;
}

.content > nav a {
	text-decoration: none;
	color: #aaa;
}
.content > nav a.active {
	color: var(--accent-color);
}
.content > nav a:hover {
	text-decoration: underline;
}

.content.docs {
	display: grid;
	grid-template-areas: "nav content";
	grid-template-columns: 15em 1fr;
	padding: 0;
}

.content.docs > article {
	box-sizing: border-box;
	grid-area: content;
	padding: 2rem;
	overflow: auto;
}


/* BIG ACTION BUTTON */

a.big-button {
	display: block;
	background-color: var(--accent-color);
	border: 1px solid var(--accent-outline-color);
	border-radius: 16px;
	box-shadow: 0 0 20px var(--accent-shadow-color),
		inset 0 0 20px var(--accent-outline-shadow-color);
	padding: 20px 24px;
	padding-bottom: 10px;
	margin-top: 3rem;
	font-family: "Bebas Neue";
	font-size: 36px;
	color: var(--accent-contrast-color);
	text-decoration: none;
	text-wrap: nowrap;
	width: min-content;
	transition: 0.5s;
}

a.big-button:hover {
	background-color: var(--accent-outline-color);
	box-shadow: 0 0 20px var(--accent-color);
	transition: 0.5s;
}

/* CODE TABS */

.code-tabs {
	background-color: #1f1f1f;
	border-radius: 16px;
	box-shadow: 0 0 20px rgb(0 0 0 / 0.3);
	padding: 8px;
}
.code-tabs ul.tabs {
	background-color: #181818;
	border-radius: 8px;
	padding: 4px 8px;
	margin: 0;
}
.code-tabs ul.tabs li {
	display: inline-block;
	margin: 0;
	padding: 0;
	margin-right: 16px;
}
.code-tabs ul.tabs li a {
	color: var(--title-color);
	text-decoration: none;
}
.code-tabs ul.tabs li a.active {
	color: var(--accent-color);
	text-decoration: none;
	font-weight: bold;
}
.code-tabs pre {
	border: none;
}
.code-tabs pre.console-output {
	margin: 0;
	background-color: #181818;
	border-radius: 8px;
}
